
_Display_Init:

;ThermostatAVR.c,86 :: 		void Display_Init()
;ThermostatAVR.c,88 :: 		Lcd_Init();                        // Initialize LCD
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	CALL       _Lcd_Init+0
;ThermostatAVR.c,89 :: 		Lcd_Cmd(_LCD_CLEAR);               // Clear display
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;ThermostatAVR.c,90 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);          // Cursor off
	LDI        R27, 12
	MOV        R2, R27
	CALL       _Lcd_Cmd+0
;ThermostatAVR.c,91 :: 		Lcd_Out(1, 1, txt1);
	LDI        R27, #lo_addr(_txt1+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt1+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;ThermostatAVR.c,92 :: 		Lcd_Out(2, 1, txt2);
	LDI        R27, #lo_addr(_txt2+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt2+0)
	MOV        R5, R27
	LDI        R27, 1
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;ThermostatAVR.c,93 :: 		Lcd_Out(1, 16, txt3);
	LDI        R27, #lo_addr(_txt3+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt3+0)
	MOV        R5, R27
	LDI        R27, 16
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;ThermostatAVR.c,94 :: 		Lcd_Out(2, 16, txt3);
	LDI        R27, #lo_addr(_txt3+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt3+0)
	MOV        R5, R27
	LDI        R27, 16
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;ThermostatAVR.c,95 :: 		}
L_end_Display_Init:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
	RET
; end of _Display_Init

_main:
	LDI        R27, 255
	OUT        SPL+0, R27
	LDI        R27, 0
	OUT        SPL+1, R27

;ThermostatAVR.c,115 :: 		void main() {
;ThermostatAVR.c,117 :: 		DDRA  = 0xFF;                                  // Configure PORTA as output
	PUSH       R2
	PUSH       R3
	PUSH       R4
	PUSH       R5
	LDI        R27, 255
	OUT        DDRA+0, R27
;ThermostatAVR.c,118 :: 		DDRC  = 0xFF;                                  // Configure PORTC as output
	LDI        R27, 255
	OUT        DDRC+0, R27
;ThermostatAVR.c,119 :: 		DDRD  = 0xFF;                                  // Configure PORTD as output
	LDI        R27, 255
	OUT        DDRD+0, R27
;ThermostatAVR.c,121 :: 		PORTA = 0x00;                                  // Initial PORTA value
	LDI        R27, 0
	OUT        PORTA+0, R27
;ThermostatAVR.c,122 :: 		PORTC = 0x00;                                  // Initial PORTC value
	LDI        R27, 0
	OUT        PORTC+0, R27
;ThermostatAVR.c,123 :: 		PORTD = 0x00;                                  // Initial PORTD value
	LDI        R27, 0
	OUT        PORTD+0, R27
;ThermostatAVR.c,126 :: 		Display_Init();
	CALL       _Display_Init+0
;ThermostatAVR.c,129 :: 		TWI_Init(100000);
	IN         R27, TWPS0_bit+0
	CBR        R27, BitMask(TWPS0_bit+0)
	OUT        TWPS0_bit+0, R27
	IN         R27, TWPS1_bit+0
	CBR        R27, BitMask(TWPS1_bit+0)
	OUT        TWPS1_bit+0, R27
	LDI        R27, 32
	OUT        TWBR+0, R27
	CALL       _TWI_Init+0
;ThermostatAVR.c,136 :: 		TE = 0;             // Thermostat function disabled - Output Relay disconnected
	IN         R27, PORTA5_bit+0
	CBR        R27, BitMask(PORTA5_bit+0)
	OUT        PORTA5_bit+0, R27
;ThermostatAVR.c,137 :: 		TRES = 0;           // Apply Reset procedure
	IN         R27, PORTA6_bit+0
	CBR        R27, BitMask(PORTA6_bit+0)
	OUT        PORTA6_bit+0, R27
;ThermostatAVR.c,138 :: 		delay_ms(150);
	LDI        R18, 7
	LDI        R17, 23
	LDI        R16, 107
L_main0:
	DEC        R16
	BRNE       L_main0
	DEC        R17
	BRNE       L_main0
	DEC        R18
	BRNE       L_main0
	NOP
;ThermostatAVR.c,139 :: 		TRES = 1;           // Temperature controller is in default state and ready for work
	IN         R27, PORTA6_bit+0
	SBR        R27, BitMask(PORTA6_bit+0)
	OUT        PORTA6_bit+0, R27
;ThermostatAVR.c,142 :: 		Set_CONFIG(0);      // Set parameters in configuration register
	CLR        R2
	CALL       _Set_CONFIG+0
;ThermostatAVR.c,151 :: 		Set_TEMP_REF(REF_TEMP);   // Set referent temperature T = 24 C (Output relay is ON until the environment
	LDI        R27, 23
	MOV        R2, R27
	CALL       _Set_TEMP_REF+0
;ThermostatAVR.c,153 :: 		Set_TEMP_HYST(HYST_TEMP); // Output Relay is OFF until the temperature falls below HYST value
	LDI        R27, 18
	MOV        R2, R27
	CALL       _Set_TEMP_HYST+0
;ThermostatAVR.c,155 :: 		TE = 1;                   // Thermostat enabled - Output Relay connected to OS output pin of MAX7502
	IN         R27, PORTA5_bit+0
	SBR        R27, BitMask(PORTA5_bit+0)
	OUT        PORTA5_bit+0, R27
;ThermostatAVR.c,158 :: 		ShortToStr(HYST_TEMP, txt);
	LDI        R27, #lo_addr(_txt+0)
	MOV        R3, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, 18
	MOV        R2, R27
	CALL       _ShortToStr+0
;ThermostatAVR.c,159 :: 		Lcd_Out(2, 11, txt);
	LDI        R27, #lo_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R5, R27
	LDI        R27, 11
	MOV        R3, R27
	LDI        R27, 2
	MOV        R2, R27
	CALL       _Lcd_Out+0
;ThermostatAVR.c,163 :: 		while (1)
L_main2:
;ThermostatAVR.c,165 :: 		Temp_read();                    // Read 9-bit temperature value from MAX7502's register space
	CALL       _Temp_Read+0
;ThermostatAVR.c,167 :: 		delay_ms(500);
	LDI        R18, 21
	LDI        R17, 75
	LDI        R16, 191
L_main4:
	DEC        R16
	BRNE       L_main4
	DEC        R17
	BRNE       L_main4
	DEC        R18
	BRNE       L_main4
	NOP
;ThermostatAVR.c,170 :: 		ShortToStr(temp_MSB, txt);
	LDI        R27, #lo_addr(_txt+0)
	MOV        R3, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R4, R27
	LDS        R2, _temp_MSB+0
	CALL       _ShortToStr+0
;ThermostatAVR.c,171 :: 		Lcd_Out(1, 11, "   ");
	LDI        R27, #lo_addr(?lstr1_ThermostatAVR+0)
	MOV        R4, R27
	LDI        R27, hi_addr(?lstr1_ThermostatAVR+0)
	MOV        R5, R27
	LDI        R27, 11
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;ThermostatAVR.c,172 :: 		Lcd_Out(1, 11, txt);
	LDI        R27, #lo_addr(_txt+0)
	MOV        R4, R27
	LDI        R27, hi_addr(_txt+0)
	MOV        R5, R27
	LDI        R27, 11
	MOV        R3, R27
	LDI        R27, 1
	MOV        R2, R27
	CALL       _Lcd_Out+0
;ThermostatAVR.c,173 :: 		}
	JMP        L_main2
;ThermostatAVR.c,175 :: 		}
L_end_main:
	POP        R5
	POP        R4
	POP        R3
	POP        R2
L__main_end_loop:
	JMP        L__main_end_loop
; end of _main

_Temp_read:

;ThermostatAVR.c,177 :: 		void Temp_read() {
;ThermostatAVR.c,178 :: 		TWI_Start();                               // TWI START condition
	PUSH       R2
	CALL       _TWI_Start+0
;ThermostatAVR.c,179 :: 		TWI_Write(SLAVE_ADDR);                     // Send slave address (RD/W = 0)
	LDI        R27, 144
	MOV        R2, R27
	CALL       _TWI_Write+0
;ThermostatAVR.c,180 :: 		TWI_Write(TEMP_REG);                       // Write pointer (temperature read only register at address 00h)
	CLR        R2
	CALL       _TWI_Write+0
;ThermostatAVR.c,181 :: 		TWI_Start();                               // Repeated start
	CALL       _TWI_Start+0
;ThermostatAVR.c,182 :: 		TWI_Write(SLAVE_ADDR | 0x01);              // Send slave address (RD/W = 1)
	LDI        R27, 145
	MOV        R2, R27
	CALL       _TWI_Write+0
;ThermostatAVR.c,183 :: 		temp_MSB = TWI_Read(1);                    // Read temp MSB byte, send acknowledge
	LDI        R27, 1
	MOV        R2, R27
	CALL       _TWI_Read+0
	STS        _temp_MSB+0, R16
;ThermostatAVR.c,184 :: 		temp_LSB = TWI_Read(0);                    // Read temp LSB byte, send not acknowledge
	CLR        R2
	CALL       _TWI_Read+0
	STS        _temp_LSB+0, R16
;ThermostatAVR.c,185 :: 		TWI_Stop();                                // I2C STOP condition
	CALL       _TWI_Stop+0
;ThermostatAVR.c,186 :: 		}
L_end_Temp_read:
	POP        R2
	RET
; end of _Temp_read

_Set_TEMP_REF:

;ThermostatAVR.c,188 :: 		void Set_TEMP_REF(unsigned short _temp) {
;ThermostatAVR.c,190 :: 		TWI_Start();                               // I2C START condition
	CALL       _TWI_Start+0
;ThermostatAVR.c,191 :: 		TWI_Write(SLAVE_ADDR);                     // Send slave address (RD/W = 0)
	PUSH       R2
	LDI        R27, 144
	MOV        R2, R27
	CALL       _TWI_Write+0
;ThermostatAVR.c,192 :: 		TWI_Write(OS_REG);                         // Set pointer
	LDI        R27, 3
	MOV        R2, R27
	CALL       _TWI_Write+0
	POP        R2
;ThermostatAVR.c,193 :: 		TWI_Write(_temp);                          // Set referent temperature
	CALL       _TWI_Write+0
;ThermostatAVR.c,194 :: 		TWI_Stop();                                // I2C STOP condition
	CALL       _TWI_Stop+0
;ThermostatAVR.c,195 :: 		}
L_end_Set_TEMP_REF:
	RET
; end of _Set_TEMP_REF

_Set_TEMP_HYST:

;ThermostatAVR.c,197 :: 		void Set_TEMP_HYST(unsigned short _temp) {
;ThermostatAVR.c,199 :: 		TWI_Start();                               // I2C START condition
	CALL       _TWI_Start+0
;ThermostatAVR.c,200 :: 		TWI_Write(SLAVE_ADDR);                     // Send slave address (RD/W = 0)
	PUSH       R2
	LDI        R27, 144
	MOV        R2, R27
	CALL       _TWI_Write+0
;ThermostatAVR.c,201 :: 		TWI_Write(HYST_REG);                       // Set pointer
	LDI        R27, 2
	MOV        R2, R27
	CALL       _TWI_Write+0
	POP        R2
;ThermostatAVR.c,202 :: 		TWI_Write(_temp);                          // Set temperature hysterezis
	CALL       _TWI_Write+0
;ThermostatAVR.c,203 :: 		TWI_Stop();                                // I2C STOP condition
	CALL       _TWI_Stop+0
;ThermostatAVR.c,204 :: 		}
L_end_Set_TEMP_HYST:
	RET
; end of _Set_TEMP_HYST

_Set_CONFIG:

;ThermostatAVR.c,206 :: 		void Set_CONFIG(unsigned short _config_value) {
;ThermostatAVR.c,208 :: 		TWI_Start();                               // I2C START condition
	CALL       _TWI_Start+0
;ThermostatAVR.c,209 :: 		TWI_Write(SLAVE_ADDR);                     // Send slave address (RD/W = 0)
	PUSH       R2
	LDI        R27, 144
	MOV        R2, R27
	CALL       _TWI_Write+0
;ThermostatAVR.c,210 :: 		TWI_Write(CONFIG_REG);                     // Set pointer
	LDI        R27, 1
	MOV        R2, R27
	CALL       _TWI_Write+0
	POP        R2
;ThermostatAVR.c,211 :: 		TWI_Write(_config_value);                  // Set temperature hysterezis
	CALL       _TWI_Write+0
;ThermostatAVR.c,212 :: 		TWI_Stop();                                // I2C STOP condition
	CALL       _TWI_Stop+0
;ThermostatAVR.c,213 :: 		}
L_end_Set_CONFIG:
	RET
; end of _Set_CONFIG
